package org.ibex.crypto;

public class HMAC extends Digest {
    private final Digest h;
    private final byte[] digest;
    private final byte[] k_ipad = new byte[64];
    private final byte[] k_opad = new byte[64];
    
    public int getDigestSize() { return h.getDigestSize(); }
    public HMAC(Digest h, byte[] key) {
        this.h = h;
        if(key.length > 64) {
            h.reset();
            h.update(key,0,key.length);
            key = new byte[h.getDigestSize()];
            h.doFinal(key,0);
        }
        digest = new byte[h.getDigestSize()];
        for(int i=0;i<64;i++) {
            byte b = i < key.length ? key[i] : 0;
            k_ipad[i] = (byte)(b ^ 0x36);
            k_opad[i] = (byte)(b ^ 0x5C);
        }
        reset();
    }
    public void reset() {
        h.reset();
        h.update(k_ipad,0,64);
    }
    public void update(byte[] b, int off, int len) { h.update(b,off,len); }
    public void doFinal(byte[] out, int off){
        h.doFinal(digest,0);
        h.update(k_opad,0,64);
        h.update(digest,0,digest.length);
        h.doFinal(out,off);
        reset();
    }
    protected void processWord(byte[] in, int inOff) {}
    protected void processLength(long bitLength) {}
    protected void processBlock() {}
}
